# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.SavedSearch do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :MemberKeyNumeric,
    :SavedSearchKeyNumeric,
    :MemberKey,
    :MemberMlsId,
    :OriginatingSystemID,
    :OriginatingSystemKey,
    :OriginatingSystemMemberKey,
    :OriginatingSystemMemberName,
    :OriginatingSystemName,
    :SavedSearchDescription,
    :SavedSearchKey,
    :SavedSearchName,
    :SearchQuery,
    :SearchQueryExceptionDetails,
    :SearchQueryHumanReadable,
    :SourceSystemID,
    :SourceSystemKey,
    :SourceSystemName,
    :ClassName,
    :ResourceName,
    :SavedSearchType,
    :SearchQueryExceptions,
    :SearchQueryType,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :Member,
    :OriginatingSystem,
    :SourceSystem,
    :Prospectings
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :MemberKeyNumeric => float() | nil,
    :SavedSearchKeyNumeric => float() | nil,
    :MemberKey => String.t | nil,
    :MemberMlsId => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemKey => String.t | nil,
    :OriginatingSystemMemberKey => String.t | nil,
    :OriginatingSystemMemberName => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :SavedSearchDescription => String.t | nil,
    :SavedSearchKey => String.t | nil,
    :SavedSearchName => String.t | nil,
    :SearchQuery => String.t | nil,
    :SearchQueryExceptionDetails => String.t | nil,
    :SearchQueryHumanReadable => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :ClassName => String.t | nil,
    :ResourceName => String.t | nil,
    :SavedSearchType => String.t | nil,
    :SearchQueryExceptions => String.t | nil,
    :SearchQueryType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :Member => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :Prospectings => [FoyerAPI.Model.Prospecting.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.SavedSearch do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:Member, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:Prospectings, :list, FoyerAPI.Model.Prospecting, options)
  end
end

